// WinSPCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "port.h"
#include "WinSPC.h"
#include "DlgWinSPC.h"
#include "DlgOptions.h"
#include "DlgSettings.h"
#include "apu.h"
#include "soundux.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgWinSPC dialog

CDlgWinSPC::CDlgWinSPC(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgWinSPC::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgWinSPC)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDlgWinSPC::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgWinSPC)
	DDX_Control(pDX, IDC_STOP, m_butStop);
	DDX_Control(pDX, IDC_REWIND, m_butRewind);
	DDX_Control(pDX, IDC_PAUSE, m_butPause);
	DDX_Control(pDX, IDC_PLAY, m_butPlay);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgWinSPC, CDialog)
	//{{AFX_MSG_MAP(CDlgWinSPC)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_FILE_OPEN, OnFileOpen)
	ON_COMMAND(IDM_FILE_OPTIONS, OnFileOptions)
	ON_COMMAND(IDM_FILE_EXIT, OnFileExit)
	ON_WM_DESTROY()
	ON_COMMAND(IDM_AUDIO_SETTINGS, OnAudioSettings)
	ON_COMMAND(IDM_HELP_ABOUT, OnHelpAbout)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_REWIND, OnRewind)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgWinSPC message handlers

extern BOOL Loaded;

BOOL CDlgWinSPC::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_butRewind.SetBitmap(::LoadBitmap(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDB_REWIND)));
	m_butPlay.SetBitmap(::LoadBitmap(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDB_PLAY)));//m_hbPlay);
	m_butPause.SetBitmap(::LoadBitmap(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDB_PAUSE)));
	m_butStop.SetBitmap(::LoadBitmap(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDB_STOP)));
	if(Loaded==TRUE){
		CString cstrTitle;
		cstrTitle.Format("%s - WinSPC",(LPCTSTR)filename);
		SendMessage(WM_SETTEXT,0,(LPARAM)(LPCTSTR)cstrTitle);
		OpenSoundDevice(&format);
		PlaySPC();
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDlgWinSPC::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDlgWinSPC::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDlgWinSPC::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDlgWinSPC::OnFileOpen() 
{
	// TODO: Add your control notification handler code here
	static char BASED_CODE szFilter[]=
		"WinSPC Files (*.spc,*.dst)|*.dst;*.spc;*.sp0;*.sp1;*.sp2;*.sp3;*.sp4;*.sp5;*.sp6;*.sp7;*.sp8;*.sp9|SPC Files (*.spc)|*.spc|DSP Stream (*.dst)|*.dst|All Files (*.*)|*.*||";
	/*static char BASED_CODE szFilter[]=
		"SPC Files (*.spc,*.zst)|*.spc;*.zst|All Files (*.*)|*.*||";*/
	CFileDialog fileDlg(TRUE,NULL,NULL,OFN_HIDEREADONLY,szFilter,this);
	POSITION pos;
	CFile file;

	if(fileDlg.DoModal()==IDOK){
		pos=fileDlg.GetStartPosition();
		CString cstrFName=fileDlg.GetNextPathName(pos);
		CString cstrExt=fileDlg.GetFileExt();
		if(cstrExt.CompareNoCase("spc")==0){
			Loaded=LoadSPC(cstrFName.GetBuffer(128));
		}else if(cstrExt.CompareNoCase("dst")==0){
			Loaded=LoadDSPStream(cstrFName.GetBuffer(128));
		}else{
			Loaded=LoadUnknown(cstrFName.GetBuffer(128));
		}
		cstrFName.ReleaseBuffer();
		if(Loaded==TRUE){
			CString cstrTitle;
			cstrTitle.Format("%s - WinSPC",(LPCTSTR)filename);
			SendMessage(WM_SETTEXT,0,(LPARAM)(LPCTSTR)cstrTitle);
			OpenSoundDevice(&format);
		}
		else AfxMessageBox("Unable to load SPC file :\n"+cstrFName);
	}
}

extern WAVEFORMATEX format;

void CDlgWinSPC::OnAudioSettings() 
{
	// TODO: Add your control notification handler code here

	CDlgSettings settings;
	switch(format.nSamplesPerSec){
	  case 4000:settings.m_nFreq=0;break;
	  case 8000:settings.m_nFreq=1;break;
	  case 16000:settings.m_nFreq=2;break;
	  case 23900:settings.m_nFreq=3;break;
	  case 24000:settings.m_nFreq=4;break;
	  case 32000:settings.m_nFreq=5;break;
	  case 44100:settings.m_nFreq=6;break;
	  case 48000:settings.m_nFreq=7;break;
	  default :settings.m_nFreq=1;format.nSamplesPerSec=8000;
	}
	switch(format.wBitsPerSample){
	  case 8:settings.m_nBits=0;break;
	  case 16:settings.m_nBits=1;break;
	  default :settings.m_nBits=0;format.wBitsPerSample=8;
	}
	switch(format.nChannels){
	  case 1:settings.m_nChan=0;break;
	  case 2:settings.m_nChan=1;break;
	  default :settings.m_nChan=0;format.nChannels=1;
	}
	settings.m_nVM=g_VM;
	if(settings.DoModal()==IDOK){
		switch(settings.m_nFreq){
		  case 0:format.nSamplesPerSec=4000;break;
		  case 1:format.nSamplesPerSec=8000;break;
		  case 2:format.nSamplesPerSec=16000;break;
		  case 3:format.nSamplesPerSec=23900;break;
		  case 4:format.nSamplesPerSec=24000;break;
		  case 5:format.nSamplesPerSec=32000;break;
		  case 6:format.nSamplesPerSec=44100;break;
		  case 7:format.nSamplesPerSec=48000;break;
		  default :format.nSamplesPerSec=8000;
		}
		switch(settings.m_nBits){
		  case 0:format.wBitsPerSample=8;break;
		  case 1:format.wBitsPerSample=16;break;
		  default :format.wBitsPerSample=8;
		}
		switch(settings.m_nChan){
		  case 0:format.nChannels=1;break;
		  case 1:format.nChannels=2;break;
		  default :format.nChannels=1;
		}
		g_VM=settings.m_nVM;
		format.wFormatTag=WAVE_FORMAT_PCM;
		format.nBlockAlign=format.nChannels*format.wBitsPerSample/8;
		format.nAvgBytesPerSec=format.nSamplesPerSec*format.nBlockAlign;
		format.cbSize=0;
		if(playing){
			OpenSoundDevice(&format);
			PlaySPC();
		}else if(Loaded){
			OpenSoundDevice(&format);
		}
	}
}

void CDlgWinSPC::OnFileOptions()
{
	CDlgOptions options;
	options.m_bSPC=TRUE;
	options.m_bDST=TRUE;
	options.m_nIcon=0;
	if(options.DoModal()==IDOK){
		CString strPathName;
		char szLongPathName[512];
		// Get Path Name
		GetModuleFileName(AfxGetInstanceHandle(),szLongPathName,512);
		if(GetShortPathName(szLongPathName,strPathName.GetBuffer(512),512)==0)
			strPathName=szLongPathName;
		strPathName.ReleaseBuffer();

		CString strTemp;
		char *buffer;
		// set the file type description
		RegSetValue(HKEY_CLASSES_ROOT,"winspcfile",REG_SZ,
			"SPC Music",lstrlen("SPC Music"));
		// set the Default Icon
		strTemp.Format("%s ,%d",strPathName,options.m_nIcon+1);
		buffer=strTemp.GetBuffer(512);
		RegSetValue(HKEY_CLASSES_ROOT,"winspcfile\\DefaultIcon",REG_SZ,
			buffer,lstrlen(buffer));
		strTemp.ReleaseBuffer();
		// set the open command
		strTemp=strPathName+" \"%1\"";
		buffer=strTemp.GetBuffer(512);
		RegSetValue(HKEY_CLASSES_ROOT,"winspcfile\\shell\\open\\command",REG_SZ,
			buffer,lstrlen(buffer));
		strTemp.ReleaseBuffer();
		// associate .spc files with our registered type
		if(options.m_bSPC){
			RegSetValue(HKEY_CLASSES_ROOT,".spc",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp0",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp1",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp2",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp3",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp4",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp5",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp6",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp7",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp8",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
			RegSetValue(HKEY_CLASSES_ROOT,".sp9",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));
		}
		if(options.m_bDST)
			RegSetValue(HKEY_CLASSES_ROOT,".dst",REG_SZ,
				"winspcfile",lstrlen("winspcfile"));

	}
}

void CDlgWinSPC::OnFileExit() 
{
	// TODO: Add your control notification handler code here

	DestroyWindow();
}

void CDlgWinSPC::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here

	CloseSoundDevice();
}

void CDlgWinSPC::OnHelpAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CDlgWinSPC::OnPause() 
{
	// TODO: Add your control notification handler code here
	
	if(Loaded){
		PauseSPC();
	}
}

void CDlgWinSPC::OnPlay() 
{
	// TODO: Add your control notification handler code here
	if(Loaded){
		PlaySPC();
	}
}

void CDlgWinSPC::OnRewind() 
{
	// TODO: Add your control notification handler code here
	if(Loaded){
		if(playing){
			PauseSPC();
			RestoreSPC();
			PlaySPC();
		}else{
			RestoreSPC();
		}
	}
}

void CDlgWinSPC::OnStop() 
{
	// TODO: Add your control notification handler code here
	
	if(Loaded){
		PauseSPC();
		RestoreSPC();
	}
}
