// WinSPC.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <mmsystem.h> //link winmm.lib
#include "WinSPC.h"
#include "DlgWinSPC.h"
#include "port.h"
#include "apu.h"
#include "soundux.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWinSPCApp

BEGIN_MESSAGE_MAP(CWinSPCApp, CWinApp)
	//{{AFX_MSG_MAP(CWinSPCApp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinSPCApp construction

CWinSPCApp::CWinSPCApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWinSPCApp object

CWinSPCApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWinSPCApp initialization

BOOL Loaded=FALSE;

BOOL CWinSPCApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();                     // Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();       // Call this when linking to MFC statically
#endif

	// Set WinSPC's Registry Key
	SetRegistryKey("WinSPC");

	// Run the Dialog
	CDlgWinSPC dlg;
	m_pMainWnd = &dlg;
	// Load the settings from the registry
	char szSettings[9]="Settings";
	dlg.format.nSamplesPerSec=GetProfileInt(szSettings,"Frequency",29300);
	dlg.format.wBitsPerSample=GetProfileInt(szSettings,"BitDepth",16);
	dlg.format.nChannels=GetProfileInt(szSettings,"Channels",2);
	g_VM=GetProfileInt(szSettings,"VM",1);
	// Fill in the rest of the format structure
	dlg.format.wFormatTag=WAVE_FORMAT_PCM;
	dlg.format.nBlockAlign=dlg.format.nChannels*dlg.format.wBitsPerSample/8;
	dlg.format.nAvgBytesPerSec=dlg.format.nSamplesPerSec*dlg.format.nBlockAlign;
	dlg.format.cbSize=0;

	S9xInitAPU();
	if(__argc>1){
		char *str;
		for(str=__argv[1];*str && *str!='.';str++);
		if(*str=='.'){
			str++;
			CString cstrExt=str;
			if(cstrExt.CompareNoCase("spc")==0){
				Loaded=LoadSPC(__argv[1]);
			}else if(cstrExt.CompareNoCase("dst")==0){
				Loaded=LoadDSPStream(__argv[1]);
			}else{
				Loaded=LoadUnknown(__argv[1]);
			}
		}
		if(Loaded==FALSE){
			CString cstrFName=__argv[1];
			AfxMessageBox("Unable to load SPC file :\n"+cstrFName);
		}
	}
	dlg.DoModal();
	S9xDeinitAPU ();

	// Save the settings to the registry
	WriteProfileInt(szSettings,"Frequency",dlg.format.nSamplesPerSec);
	WriteProfileInt(szSettings,"BitDepth",dlg.format.wBitsPerSample);
	WriteProfileInt(szSettings,"Channels",dlg.format.nChannels);
	WriteProfileInt(szSettings,"VM",g_VM);

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

