#include "StdAfx.h"

#include <mmsystem.h> //don't forget to link to winmm.lib
#include "port.h"
#include "apu.h"
#include "soundux.h"

int g_VM=1;
CString filename;

 // Snes9x's Mixer
extern void S9xMixSamples (unsigned char *, int);

 // Mixes Per Second
#define MPS 100
 // Buffers Per Second (Keep this low for windows)
#define BPS 4
 // Mixes Per Buffer
#define MPB (MPS/BPS)
 // Clocks Per Mix (the SPC is 2.048 Mhz)
#define CPM (2048000/MPS)
 // How many 32 Clocks Per Mix
#define C32PM (2048000/MPS)/32

 // Bytes Per Mix
int bpm=0;
 // Bytes Per Buffer
int bpb=0;
 // Samples Per Mix (double for stereo)
int spm=0;

HWAVEOUT hwo=0;
WAVEHDR wh[4];
BOOL playing=FALSE;

SAPURegisters BackupAPURegisters;
unsigned char BackupAPURAM[65536];
unsigned char BackupAPUExtraRAM[64];
unsigned char BackupDSPRAM[128];

SDSPStream dspstream;
unsigned long curdspbuffer=0;
char DSP=0;

// The callback

void DoTimer(){
	if (APU.TimerEnabled [2])
	{
		APU.Timer [2]++;
		if (APU.Timer [2] >= APU.TimerTarget [2])
		{
			IAPU.RAM [0xff] = (IAPU.RAM [0xff] + 1) & 0xf;
			APU.Timer [2] = 0;
#ifdef SPC700_SHUTDOWN          
			IAPU.WaitCounter++;
			IAPU.APUExecuting = TRUE;
#endif          

		}
	}
	if (IAPU.TimerErrorCounter>=8)
	{
		IAPU.TimerErrorCounter=0;
		if (APU.TimerEnabled [0])
		{
			APU.Timer [0]++;
			if (APU.Timer [0] >= APU.TimerTarget [0])
			{
				IAPU.RAM [0xfd] = (IAPU.RAM [0xfd] + 1) & 0xf;
				APU.Timer [0] = 0;
#ifdef SPC700_SHUTDOWN          
				IAPU.WaitCounter++;
				IAPU.APUExecuting = TRUE;
#endif          

			}
		}
		if (APU.TimerEnabled [1])
		{
			APU.Timer [1]++;
			if (APU.Timer [1] >= APU.TimerTarget [1])
			{
				IAPU.RAM [0xfe] = (IAPU.RAM [0xfe] + 1) & 0xf;
				APU.Timer [1] = 0;
#ifdef SPC700_SHUTDOWN          
				IAPU.WaitCounter++;
				IAPU.APUExecuting = TRUE;
#endif          
			}
		}
	}
}

void CALLBACK waveOutProcSPC(HWAVEOUT hWo,UINT uMsg,DWORD dwInstance, 
						  DWORD dwParam1,DWORD dwParam2){
	int i;
	WAVEHDR *whdr=(WAVEHDR*)dwParam1;

	if(!playing)return;
	switch(uMsg){
	  case WOM_DONE:
		whdr->dwUser=TRUE;//Mixing
		waveOutUnprepareHeader(hWo,whdr,sizeof(WAVEHDR));

		for(i=0;i<MPB;i++){
			//if(IAPU.APUExecuting)
			{
				// APU_LOOP
				for(int c=0;c<C32PM;c++){
					for(int ic=0;ic<32;ic++){
						APU_EXECUTE1();
					}
					IAPU.TimerErrorCounter++;
					DoTimer();
				}
			}
			S9xMixSamples((unsigned char *)(&whdr->lpData[i*bpm]),(spm));
		}
		whdr->dwUser=FALSE; //Not Mixing
		
		if(playing)
		{
			whdr->dwBufferLength=bpb;
			whdr->dwFlags=0;
			waveOutPrepareHeader(hWo,whdr,sizeof(WAVEHDR));
			waveOutWrite(hWo,whdr,sizeof(WAVEHDR));
		}
		break;
	}
}

void CALLBACK waveOutProcDSP(HWAVEOUT hWo,UINT uMsg,DWORD dwInstance, 
						  DWORD dwParam1,DWORD dwParam2){
	int i;
	WAVEHDR *whdr=(WAVEHDR*)dwParam1;

	if(!playing)return;
	switch(uMsg){
	  case WOM_DONE:
		whdr->dwUser=TRUE;//Mixing
		waveOutUnprepareHeader(hWo,whdr,sizeof(WAVEHDR));

		for(i=0;i<MPB;i++){
			SDSPBuffer *dspbuf=&dspstream.dspbuffer[curdspbuffer];
			for(unsigned long c=0;c<dspbuf->length;c++){
				IAPU.RAM[0xf2]=dspbuf->setdsp[c].reg;
				S9xSetAPUDSP(dspbuf->setdsp[c].data);
			}
			curdspbuffer++;
			if(curdspbuffer>=dspstream.length){
				RestoreSPC();
				//curdspbuffer=0;
			}
			S9xMixSamples((unsigned char *)(&whdr->lpData[i*bpm]),(spm));
		}
		whdr->dwUser=FALSE; //Not Mixing
		
		if(playing)
		{
			whdr->dwBufferLength=bpb;
			whdr->dwFlags=0;
			waveOutPrepareHeader(hWo,whdr,sizeof(WAVEHDR));
			waveOutWrite(hWo,whdr,sizeof(WAVEHDR));
		}
		break;
	}
}
// Play SPC

void PlaySPC(){
	int i,b;

	if(hwo&&playing==FALSE){
		if(DSP==0){
			for(b=0;b<BPS;b++){
				for(i=0;i<MPB;i++){
					//if(IAPU.APUExecuting)
					{
						// APU_LOOP
						for(int c=0;c<C32PM;c++){
							for(int ic=0;ic<32;ic++){
								APU_EXECUTE1();
							}
							IAPU.TimerErrorCounter++;
							DoTimer();
						}
					}
					S9xMixSamples((unsigned char *)(&wh[b].lpData[i*bpm]),spm);
				}
			}
		}else{
			for(b=0;b<BPS;b++){
				for(i=0;i<MPB;i++){
					SDSPBuffer *dspbuf=&dspstream.dspbuffer[curdspbuffer];
					for(unsigned long c=0;c<dspbuf->length;c++){
						IAPU.RAM[0xf2]=dspbuf->setdsp[c].reg;
						S9xSetAPUDSP(dspbuf->setdsp[c].data);
					}
					curdspbuffer++;
					if(curdspbuffer>=dspstream.length)curdspbuffer=0;
					S9xMixSamples((unsigned char *)(&wh[b].lpData[i*bpm]),spm);
				}
			}
		}
		playing=TRUE;
		for(b=0;b<BPS;b++){
			wh[b].dwBufferLength=bpb;
			wh[b].dwFlags=0;
			wh[b].dwUser=FALSE;
			waveOutPrepareHeader(hwo,&wh[b],sizeof(WAVEHDR));
			waveOutWrite(hwo,&wh[b],sizeof(WAVEHDR));
		}
	}
}

// Pause SPC

void PauseSPC(){
	if(hwo&&playing){
		playing=FALSE;
		waveOutReset(hwo);
	}
}

// Open Sound Device

BOOL OpenSoundDevice (WAVEFORMATEX *format)
{
	int b;
	MMRESULT mmResult;

	CloseSoundDevice(); //Close a previously opened Devices

	//SPC mixer information
    so.stereo = (format->nChannels==2)?TRUE:FALSE;//TRUE;//in_stereo;
    so.sixteen_bit = (format->wBitsPerSample==16)?TRUE:FALSE;//TRUE;//sixteen_bit;
    so.playback_rate = format->nSamplesPerSec;//44100;//playback_rate;
    so.buffer_size = format->nSamplesPerSec/MPS;//buffer_size;
    so.encoded = FALSE;
    so.mute_sound = FALSE;

	if(DSP==0){
	    if((mmResult=waveOutOpen(&hwo,WAVE_MAPPER,format
		  ,(DWORD)waveOutProcSPC,0,CALLBACK_FUNCTION//|WAVE_ALLOWSYNC
		  ))!=MMSYSERR_NOERROR){
			hwo=0;
			return FALSE;
	    }
	}else{
	    if((mmResult=waveOutOpen(&hwo,WAVE_MAPPER,format
		  ,(DWORD)waveOutProcDSP,0,CALLBACK_FUNCTION//|WAVE_ALLOWSYNC
		  ))!=MMSYSERR_NOERROR){
			hwo=0;
			return FALSE;
	    }
	}

	//Buffer mixing information
	bpb=format->nAvgBytesPerSec/BPS;
	bpm=format->nAvgBytesPerSec/MPS;
	spm=format->nSamplesPerSec*format->nChannels/MPS;
	for(b=0;b<BPS;b++){
		wh[b].lpData=new char[bpb];
	}

    return TRUE;
}

// Close Sound Device

void CloseSoundDevice(){
	int i;

	if(hwo!=0){
		playing=FALSE;
		waveOutReset(hwo);
		while(waveOutClose(hwo)==WAVERR_STILLPLAYING);
		for(i=0;i<BPS;i++){
			while(wh[i].dwUser==TRUE);
		}
		hwo=0;
		for(i=0;i<BPS;i++){
			delete [] wh[i].lpData;
		}
	}
}

// Restore SPC Load State

void FixEnvelope (int channel, uint8 gain, uint8 adsr1, uint8 adsr2);
void StartSample (int channel);
void S9xSetAPUDSP (uint8 byte);

void RestoreSPC(){
	int i;

	APURegisters.PC = BackupAPURegisters.PC;
	APURegisters.YA.B.A = BackupAPURegisters.YA.B.A;
	APURegisters.X = BackupAPURegisters.X;
	APURegisters.YA.B.Y = BackupAPURegisters.YA.B.Y;
	APURegisters.P = BackupAPURegisters.P;
	APURegisters.S = BackupAPURegisters.S;
	memcpy(IAPU.RAM,BackupAPURAM,65536);
	memcpy(APU.ExtraRAM,BackupAPUExtraRAM,64);
	memcpy(APU.DSP,BackupDSPRAM,128);

	for(i=0;i<4;i++){
		APU.OutPorts [i] = IAPU.RAM[0xf4+i];
	}
	IAPU.TimerErrorCounter=0;
	for (i=0;i<3;i++){
		if (IAPU.RAM[0xfa+i] == 0)
			APU.TimerTarget[i] = 0x100;
		else
			APU.TimerTarget[i] = IAPU.RAM[0xfa+i];
	}
	S9xSetAPUControl(IAPU.RAM[0xf1]);
	S9xSetSoundMute (FALSE);
	IAPU.PC = IAPU.RAM + APURegisters.PC;
	S9xAPUUnpackStatus();
	if (APUCheckDirectPage ())
		IAPU.DirectPage = IAPU.RAM + 0x100;
	else
		IAPU.DirectPage = IAPU.RAM;
	IAPU.APUExecuting = TRUE;

	S9xFixSoundAfterSnapshotLoad();

	S9xSetFrequencyModulationEnable(APU.DSP[APU_PMON]);
	S9xSetMasterVolume(APU.DSP[APU_MVOL_LEFT],APU.DSP[APU_MVOL_RIGHT]);
	S9xSetEchoVolume(APU.DSP[APU_EVOL_LEFT],APU.DSP[APU_EVOL_RIGHT]);
	uint8 mask = 1;
	int type;
	for(i=0;i<8;i++,mask<<=1){
		FixEnvelope (i,
			APU.DSP[APU_GAIN+(i<<4)],
			APU.DSP[APU_ADSR1+(i<<4)],
			APU.DSP[APU_ADSR2+(i<<4)]);
		S9xSetSoundVolume (i,
			APU.DSP[APU_VOL_LEFT+(i<<4)],
			APU.DSP[APU_VOL_RIGHT+(i<<4)]);
        S9xSetSoundFrequency (i,
			((APU.DSP[APU_P_LOW+(i<<4)]+(APU.DSP[APU_P_HIGH+(i<<4)]<< 8))&FREQUENCY_MASK)*8);
		if (APU.DSP [APU_NON] & mask){
			type = SOUND_NOISE;
		}else{
			type = SOUND_SAMPLE;
		}
		S9xSetSoundType (i, type);
		if ((APU.DSP[APU_KON] & mask) != 0){
			APU.KeyedChannels |= mask;
			StartSample (i);
		}
	}
	/*unsigned char temp=IAPU.RAM[0xf2];
	for(i=0;i<128;i++){
		IAPU.RAM[0xf2]=i;
		S9xSetAPUDSP(APU.DSP[i]);
	}
	IAPU.RAM[0xf2]=temp;*/
	curdspbuffer=0;
}

// Load SPC file

BOOL LoadSPC(char *fname)
{
	CFile file;
	char temp[64];

	if(file.Open(fname,CFile::modeRead))
	{
		S9xResetAPU();

		file.Seek(0x25,CFile::begin);
		file.Read(&BackupAPURegisters.PC,2);
		file.Read(&BackupAPURegisters.YA.B.A,1);
		file.Read(&BackupAPURegisters.X,1);
		file.Read(&BackupAPURegisters.YA.B.Y,1);
		file.Read(&BackupAPURegisters.P,1);
		file.Read(&BackupAPURegisters.S,1);
		file.Seek(0x100,CFile::begin);
		file.Read(BackupAPURAM,65536);
		file.Read(BackupDSPRAM,128);
		file.Read(temp,64);
		file.Read(BackupAPUExtraRAM,64);

		filename=file.GetFileName();
		file.Close();

		RestoreSPC();
		
		DSP=0;
		return TRUE;
	}
	return FALSE;
}

void SetLength(SDSPStream *stream, unsigned long length){
    unsigned long i;
    if(length==0){
        stream->length=0;
        stream->dspbuffer=0;
    }else{
        stream->length=length;
        stream->dspbuffer=new SDSPBuffer[length];
        for(i=0;i<length;i++){
            stream->dspbuffer[i].length=0;
            stream->dspbuffer[i].setdsp=0;
        }
    }
}

// Load DSP Stream file

BOOL LoadDSPStream(char *fname)
{
	CFile file;
	unsigned long temp,i,j;

	if(file.Open(fname,CFile::modeRead))
	{
		S9xResetAPU();

		file.Read(&temp,4);//DSPS marker

		file.Read(&temp,4);//RAM  marker
		file.Read(BackupAPURAM,65536);//Load RAM

		file.Read(&temp,4);//DSP  marker
		file.Read(BackupDSPRAM,128);//Load RAM

		file.Read(&temp,4);//STRE marker
		file.Read(&temp,4);//number of Stream length
		SetLength(&dspstream,temp);
		for(i=0;i<dspstream.length;i++){
			file.Read(&temp,4);//Stream length
			dspstream.dspbuffer[i].length=temp;
			dspstream.dspbuffer[i].setdsp=new SSetDSP[temp];
			for(j=0;j<dspstream.dspbuffer[i].length;j++){
				file.Read(&dspstream.dspbuffer[i].setdsp[j].reg,1);
				file.Read(&dspstream.dspbuffer[i].setdsp[j].data,1);
			}
		}

		filename=file.GetFileName();
		file.Close();
		RestoreSPC();
		DSP=1;
		return TRUE;
	}
	return FALSE;
}

BOOL LoadUnknown(char *fname){
	CFile file;
	unsigned long temp;

	if(file.Open(fname,CFile::modeRead))
	{
		file.Read(&temp,4);//DSPS marker
		file.Close();
		if(temp==0x53505344){
			return LoadDSPStream(fname);
		}else{
			return LoadSPC(fname);
		}
	}
	return FALSE;
}
